package com.university;

import com.university.Course;
import com.university.Department;
import com.university.Professor;
import com.university.Student;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.Before;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

public class CourseTest {
    static Course course;
    static Department department;
    static Professor professor;
    @BeforeClass
    public static void createCourse(){
        department = new Department("Computer & IT Engineering");
        professor = new Professor(department , "Javadi");
        Student student = new Student("Alireza" , "1234" , "SE" , department);
        course = new Course("1" , "computer" , department , professor , 10);
        course.enrollStudent(student);
    }
    @Test
    public void getCourseDepartmentTest(){
        assertNotNull(course.getDepartment());
        assertEquals(department , course.getDepartment());
    }
    @Test
    public void getCourseNameTest(){
        assertNotNull(course.getName());
        assertEquals("computer" , course.getName());
    }
    @Test
    public void courseGetProfessorTest(){
        assertNotNull(course.getProfessor());
        assertEquals(professor , course.getProfessor());
    }
    @Test
    public void enrollStudentTest(){
        assertNotNull(course.getStudents());
        assertEquals(1 , course.getStudents().length);
    }
    @Test
    public void notEnrollStudentTest(){
        Student[] student = course.getStudents();
        for(int i=0 ; i < (course.getStudents().length) ; i++){
            assertEquals(student[i].getDepartment().getName() , "Computer & IT Engineering");
        }
    }
}
